/**************************************************
 *  IoTAmbient
 * @@PIC16F18313
 * @@ESPWROOM02{xZT
 * @@AmbientM
 *************************************************/
#include "mcc_generated_files/mcc.h"
#include <string.h>

char Body[] =  "\"32.1\",\"d2\":\"45.6\"}\r\n";
char DataByte[5], data[54], Flag, Temp;
uint16_t Temperature, Humidity;
/** ֐vg **/
bool getResponse(char *word, uint16_t timeout);
void GetSensor(void);
void SendStr(char * Buf);
/*********************************
 * ^C}O荞ݏ
 *********************************/
void TMR0_Process(void){
    Flag = 1;
}
/******** C֐ *****************************/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}0荞Callback`
    TMR0_SetInterruptHandler(TMR0_Process);
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    /***** C[v *******************/
    while (1)
    {
        if(Flag == 1){                                  // 3
            Flag = 0;
            LED_SetHigh();
            /****** POSTf[^쐬 **********/            
            // ZTf[^擾 2
            GetSensor();
            Humidity = (uint16_t)DataByte[0]*256 + DataByte[1];
            Temperature = (uint16_t)DataByte[2]*256 + DataByte[3];
            // ɕϊobt@Ɋi[
            Body[1] = (char)(Temperature / 100) + '0';
            Temperature %= 100;
            Body[2] = (char)(Temperature /10) + '0';
            Body[4] = (char)(Temperature % 10) + '0';            
            Body[13] = (char)(Humidity / 100)  + '0';
            Humidity %= 100;
            Body[14] = (char)(Humidity / 10) + '0';
            Body[16] = (char)(Humidity % 10) + '0';            
            /****** Ambient֑Ms ************/
            /***ANZX|CgƐڑ@****/
            // ESP Initialize
            SendStr("AT+CWMODE=1\r\n");                  // Xe[V[h 
            getResponse("OK", 1);     
            do{
                SendStr("AT+CWJAP=\"Buffalo-G-6370\",\"7tb7ksh8i44bc\"\r\n");                
            }while(getResponse("GOT IP", 10)==false);   // GOT IPԂ܂ŌJԂ              
            /** AmbientT[oƐڑ **/
            do{            
                SendStr("AT+CIPSTART=\"TCP\",\"54.65.206.59\",80\r\n");                
            }while(getResponse("CONNECT", 5)==false);   // CONNECTɂȂ܂ŌJԂ            
            // TCPAmbientPOSTM
            SendStr("AT+CIPSEND=174\r\n");              // M                                       
            getResponse(">", 3);                        // OK >҂ 
            SendStr("POST /api/v2/channels/44249/data HTTP/1.1\r\n");
            SendStr("Host: 54.65.206.59\r\n");
            SendStr("Content-Length: 57\r\n");
            SendStr("Content-Type: application/json\r\n\r\n");
            // BodyM
            SendStr("{\"writeKey\":\"eaa1c8e15a644f94\",\"d1\":");
            SendStr(Body);                               // M  
            getResponse("SEND OK", 3);                  // SEND OK҂
            // Ambient̉҂
            getResponse("200 OK", 5);                   // HTTP/1.1 200 OK҂             
            getResponse("CLOSED", 3);                   // CLOSED҂             
            __delay_ms(500);
            SendStr("AT+CWQAP\r\n");                     // APƂ̐ڑ
            getResponse("OK", 3);
            LED_SetLow();
        }
    }
}
/***********************************
 * 񑗐M֐
 ***********************************/
void SendStr(char * Buf){
    char* ptr;
    
    ptr = Buf;                  // |C^l
    while(*ptr != 0){           // 0łȂꍇ
        EUSART_Write(*ptr);     // |C^ŕoM
        ptr++;                  // |C^XV
    }
}
/************************************************
 *  ESPR}h҂
 * @^C}PŃ^CAEgo
 *@ Timer1 31kHz/8=3875 -> 1sec @Max 16sec
 ************************************************/
bool getResponse(char *word, uint16_t timeout){
    char a, flag;
    uint16_t j;
    
    j = 0;                                      // CfbNXZbg    
    flag = 0;                                   // 񔭌tOZbg
    TMR1_WriteTimer(0xFFFF-timeout*3874);       // ^C}bZbg
    TMR1_StartTimer();                          // ^C}PX^[g
    PIR1bits.TMR1IF = 0;                        // ^C}tOZbg    
    /** Ms ****/
    while(PIR1bits.TMR1IF == 0){                // ^CAbv܂ŌJԂ
        while(EUSART_is_rx_ready() == true){    // Mf[^̏ꍇ
            a = (char)EUSART_Read();            // Mf[^擾
            if(a == '\0') continue;             // 0x00͏Ȃ
            data[j] = a;                        // Mobt@ɒǉ
            if(j<52)                            // 30ȏ͖
                j++;                            // ̃obt@
            data[j] = 0;                        // ĨtO
        }
        // Mf[^
        if(( a == '\n')||(a == '>')){           // ̏Ȉꍇ܂́̏ꍇ
            if(strstr(data, word) != 0){        // 񌟍
                flag = 1;                       // 񔭌tOI
                TMR1_StopTimer();               // ^C}1~
                break;                          // I
            }
            j = 0;                              // obt@̍ŏɖ߂
        }
    }
    // ߂lZbg
    if(flag == 1)
        return true;                            // 񂪌ꍇ
    else
        return false;                           // ^CAbv̏ꍇ      
}
/*******************************************
 *  AM2320 Get Data 
 *   5Byte HumiH+HumiL+TempH+TempL+Check
 ********************************************/
void GetSensor(void){
    uint8_t i, j, pos;
    // Output StartPulse
    SDA_SetLow();    
    SDA_TRIS = 0;                           // o̓[h
    __delay_ms(2);                          // 2msec
    SDA_SetHigh();
    SDA_TRIS = 1;                           // ̓[h 
    __delay_us(150);                        // ŏ̃pXXLbv
    while(SDA_GetValue() == 1);             // High̊ԑ҂
    // Get 40bit data 5 byte
    for(j=0; j<5; j++){                     // 5oCgJԂ
        DataByte[j] = 0;                    // f[^Zbg
        pos = 0x80;                         // ŏʃrbg
        for(i=0; i<8; i++){                 // 8rbgJԂ
            while(SDA_GetValue() == 0);     // Low50usec҂
            __delay_us(40);                 // 40usecXLbv          
            if(SDA_GetValue() == 1){        // 01̔
                DataByte[j] |= pos;         // 1̏ꍇZbg
                while(SDA_GetValue() == 1); // rbgI҂  
            }
            pos >>= 1;                      // ̃rbg
         }
    }
}
